/**
 * A class to hold a variety of examples of boolean expressions and conditionals.
 * 
 * @author Stephen Bloch
 * @version 11 March 2004
 */
public class Conditionals
{
    public static boolean over18 (int age) {
        return age > 18;
    }
    
    public static boolean from18to25 (int age) {
        return age >= 18 && age <= 25;
    }
    
    public static boolean atLeast100or18to25 (int age) {
        return age >= 100 || from18to25 (age);
    }
    
    public static boolean easyBetween (int num, int lowerLimit, int upperLimit) {
        return lowerLimit < num && num < upperLimit;
    }
    
    public static boolean hardBetween (int num, int oneLimit, int otherLimit) {
/* One way to do this:
        return (oneLimit < num && num < otherLimit) ||
               (oneLimit > num && num > otherLimit);
*/

/* Another way to do this:
        if (oneLimit < otherLimit)
            return oneLimit < num && num < otherLimit;
        else // oneLimit >= otherLimit 
            return oneLimit > num && num > otherLimit;
*/

/* A third way to do this:
        if (oneLimit < otherLimit)
            return easyBetween (num, oneLimit, otherLimit);
        else
            return easyBetween (num, otherLimit, oneLimit);
    }
*/

/* And a fourth way: */
        return easyBetween (num, oneLimit, otherLimit) ||
               easyBetween (num, otherLimit, oneLimit);
           }

    /**
     * classify someone by age as either "child" (under 13) or "adult" (13 and up).
     * 
     * @param age    the person's age
     * @return a String, either "child" or "adult".
     */
    public static String easyAgeGroup (int age) {
        if (age < 13) {
            return "child";
        }
        else {
            return "adult";
        }
    }
/* Note that if there's only one statement in each half of the "if...else...",
 * you don't HAVE to have curly-braces around them, but it's generally a good
 * idea, and CheckStyle will warn you about not having the curly-braces there.
 */

    /** classify someone by age as "child", "teenager", or "adult".
     * 
     * @param age   the person's age
     * @return a String, either "child", "teenager", or "adult"..
     */
    public static String hardAgeGroup (int age) {
        if (age < 13) {
            return "child";
        }
        else if (age >= 13 && age <= 19) {
            return "teenager";
        }
        else {
            return "adult";
        }
    }
    
    /** classify someone by age as "child", "teenager", or "adult".
     * This does exactly the same thing as the previous method, but
     * the second case is simplified, because if age weren't at least 13,
     * the first case would have caught it and the computer would never
     * have reached the second case at all.
     * 
     * @param age   the person's age
     * @return a String, either "child", "teenager", or "adult"..
     */
    public static String shorterAgeGroup (int age) {
        if (age < 13) {
            return "child";
        }
        else if (age <= 19) {
            return "teenager";
        }
        else {
            return "adult";
        }
    }
}
